<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>SpaceFighter2020: src/Enemy.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">SpaceFighter2020
   </div>
   <div id="projectbrief">This documentation reffers to the game Space Fighter 2020 created for pa2 course. Game is side-scrolling shooter where the goal is to get on the end of the level and kill as much as enemy ships as possible. Player can pick up bonuses for repairing point of health or upgrading his weapons.</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">Enemy.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="Enemy_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#ifndef Enemy_H</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#define Enemy_H</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160; </div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160; </div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="Entity_8h.html">Entity.h</a>&quot;</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160; </div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="keyword">class </span><a class="code" href="classCollisionVisitor.html">CollisionVisitor</a>;</div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160; </div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160; </div>
<div class="line"><a name="l00015"></a><span class="lineno"><a class="line" href="classEnemy.html">   15</a></span>&#160;<span class="keyword">class </span><a class="code" href="classEnemy.html">Enemy</a> : <span class="keyword">public</span> <a class="code" href="classEntity.html">Entity</a>{</div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;    <a class="code" href="classEnemy.html#a2088aa94084a3c64c45f163e44503941">Enemy</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> &amp; x,<span class="keyword">const</span> <span class="keywordtype">int</span> &amp; y);</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160; </div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classEnemy.html#a42ec023b4093dcc4d68a7c9f9137d5a5">Damage</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> &amp; dmg)<span class="keyword">override</span>;</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160; </div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classEnemy.html#a59c9fcc0c3f927e15060a61b4753b1b3">BonusRoll</a> ();</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160; </div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classEnemy.html#a614ad271f07ecf63cb3e665155b7e258">Update</a>()<span class="keyword">override</span>;</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classEnemy.html#a44cdcdae0c7341918adbcfb7489d6b1f">Visit</a> (<a class="code" href="classCollisionVisitor.html">CollisionVisitor</a> * visitor) <span class="keyword">override</span>;</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classEnemy.html#ac4582c2a7ccffc4dd2b8fd1d43017c33">CollideWith</a> (<a class="code" href="classGameObject.html">GameObject</a> * collisionObject) <span class="keyword">override</span>;</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160; </div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00046"></a><span class="lineno"><a class="line" href="classEnemy.html#afba0cb1bba4839d19a4ea80dacbf5bcf">   46</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="classEnemy.html#afba0cb1bba4839d19a4ea80dacbf5bcf">m_ScoreValue</a>;</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;};</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160; </div>
<div class="line"><a name="l00053"></a><span class="lineno"><a class="line" href="classFighter.html">   53</a></span>&#160;<span class="keyword">class </span><a class="code" href="classFighter.html">Fighter</a> : <span class="keyword">public</span> <a class="code" href="classEnemy.html">Enemy</a>{</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    <a class="code" href="classFighter.html#ad59b81c018ee965870f46fee88a5d469">Fighter</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> &amp; x,<span class="keyword">const</span> <span class="keywordtype">int</span> &amp; y);</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classFighter.html#a111291f871d86c69177b66b832078899">SetupStats</a>()<span class="keyword">override</span>;</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classFighter.html#a0ecbca6d3e98a60aa971c596375846c5">InitWeapon</a>()<span class="keyword">override</span>;</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;};</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160; </div>
<div class="line"><a name="l00065"></a><span class="lineno"><a class="line" href="classBomber.html">   65</a></span>&#160;<span class="keyword">class </span><a class="code" href="classBomber.html">Bomber</a> : <span class="keyword">public</span> <a class="code" href="classEnemy.html">Enemy</a>{</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;    <a class="code" href="classBomber.html#a8ebefb9c1db1d57f944ebafc53cb4396">Bomber</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> &amp; x,<span class="keyword">const</span> <span class="keywordtype">int</span> &amp; y);</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classBomber.html#a978b4fce46f9b875fc412cb20bc2c001">SetupStats</a>()<span class="keyword">override</span>;</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classBomber.html#af331f516205a9310d07cad2869391ff1">InitWeapon</a>()<span class="keyword">override</span>;</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;};</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160; </div>
<div class="line"><a name="l00077"></a><span class="lineno"><a class="line" href="classDrone.html">   77</a></span>&#160;<span class="keyword">class </span><a class="code" href="classDrone.html">Drone</a> : <span class="keyword">public</span> <a class="code" href="classEnemy.html">Enemy</a>{</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    <a class="code" href="classDrone.html#a712934f484aa8b1a8f5d521f870217c0">Drone</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> &amp; x,<span class="keyword">const</span> <span class="keywordtype">int</span> &amp; y);</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classDrone.html#afdee1b510410d6512bd9898cfbbf2faf">SetupStats</a>()<span class="keyword">override</span>;</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classDrone.html#af9fc8b290a80200d599b85b82f27db6b">InitWeapon</a>()<span class="keyword">override</span>;</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160; </div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classDrone.html#a5f337d0f09b7b6b7227f3e1eee7214d2">OnBorderCollision</a>() <span class="keyword">override</span>;</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;};</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160; </div>
<div class="line"><a name="l00095"></a><span class="lineno"><a class="line" href="classCruiser.html">   95</a></span>&#160;<span class="keyword">class </span><a class="code" href="classCruiser.html">Cruiser</a> : <span class="keyword">public</span> <a class="code" href="classEnemy.html">Enemy</a>{</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;    <a class="code" href="classCruiser.html#a28d17733c541e9985c3cab7efccc8138">Cruiser</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> &amp; x,<span class="keyword">const</span> <span class="keywordtype">int</span> &amp; y);</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classCruiser.html#a82e7c6812c341ef137c0397f5d39010b">Update</a>()<span class="keyword">override</span>;</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classCruiser.html#a1bdf01c4ccf5cb4305710274cfe5ae65">SetupStats</a>()<span class="keyword">override</span>;</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classCruiser.html#ae47dfbab1b9f7837d138f617a43593c1">InitWeapon</a>()<span class="keyword">override</span>;</div>
<div class="line"><a name="l00106"></a><span class="lineno"><a class="line" href="classCruiser.html#acee2ca8436026b2cd7562c5b45d5add1">  106</a></span>&#160;    std::chrono::time_point&lt;std::chrono::system_clock&gt; <a class="code" href="classCruiser.html#acee2ca8436026b2cd7562c5b45d5add1">m_Clock</a>; </div>
<div class="line"><a name="l00107"></a><span class="lineno"><a class="line" href="classCruiser.html#a4a854fd717b42079b7b91bc4c06de455">  107</a></span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classCruiser.html#a4a854fd717b42079b7b91bc4c06de455">m_StateSwitch</a>;</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;};</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160; </div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160; </div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160; </div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160; </div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* Enemy_H */</span><span class="preprocessor"></span></div>
</div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="aclassGameObject_html"><div class="ttname"><a href="classGameObject.html">GameObject</a></div><div class="ttdoc">Abstract class that represents GameObject with collision and movement properties.</div><div class="ttdef"><b>Definition:</b> GameObject.h:14</div></div>
<div class="ttc" id="aclassBomber_html_af331f516205a9310d07cad2869391ff1"><div class="ttname"><a href="classBomber.html#af331f516205a9310d07cad2869391ff1">Bomber::InitWeapon</a></div><div class="ttdeci">void InitWeapon() override</div><div class="ttdoc">Pure virtual function for initializing weapon.</div><div class="ttdef"><b>Definition:</b> Enemy.cpp:101</div></div>
<div class="ttc" id="aclassDrone_html_af9fc8b290a80200d599b85b82f27db6b"><div class="ttname"><a href="classDrone.html#af9fc8b290a80200d599b85b82f27db6b">Drone::InitWeapon</a></div><div class="ttdeci">void InitWeapon() override</div><div class="ttdoc">Pure virtual function for initializing weapon.</div><div class="ttdef"><b>Definition:</b> Enemy.cpp:124</div></div>
<div class="ttc" id="aclassDrone_html"><div class="ttname"><a href="classDrone.html">Drone</a></div><div class="ttdoc">Fast low health enemy, bounces off borders.</div><div class="ttdef"><b>Definition:</b> Enemy.h:77</div></div>
<div class="ttc" id="aclassDrone_html_a5f337d0f09b7b6b7227f3e1eee7214d2"><div class="ttname"><a href="classDrone.html#a5f337d0f09b7b6b7227f3e1eee7214d2">Drone::OnBorderCollision</a></div><div class="ttdeci">void OnBorderCollision() override</div><div class="ttdoc">Overrides function to bounce off borders.</div><div class="ttdef"><b>Definition:</b> Enemy.cpp:132</div></div>
<div class="ttc" id="aclassBomber_html_a8ebefb9c1db1d57f944ebafc53cb4396"><div class="ttname"><a href="classBomber.html#a8ebefb9c1db1d57f944ebafc53cb4396">Bomber::Bomber</a></div><div class="ttdeci">Bomber(const int &amp;x, const int &amp;y)</div><div class="ttdef"><b>Definition:</b> Enemy.cpp:84</div></div>
<div class="ttc" id="aclassCruiser_html_a82e7c6812c341ef137c0397f5d39010b"><div class="ttname"><a href="classCruiser.html#a82e7c6812c341ef137c0397f5d39010b">Cruiser::Update</a></div><div class="ttdeci">void Update() override</div><div class="ttdoc">Overrides function to change states (move/fire) depending on m_clock.</div><div class="ttdef"><b>Definition:</b> Enemy.cpp:147</div></div>
<div class="ttc" id="aclassCruiser_html"><div class="ttname"><a href="classCruiser.html">Cruiser</a></div><div class="ttdoc">High health high fire rate enemy, cannot move while firing has cooldown on fire.</div><div class="ttdef"><b>Definition:</b> Enemy.h:95</div></div>
<div class="ttc" id="aclassEnemy_html_a2088aa94084a3c64c45f163e44503941"><div class="ttname"><a href="classEnemy.html#a2088aa94084a3c64c45f163e44503941">Enemy::Enemy</a></div><div class="ttdeci">Enemy(const int &amp;x, const int &amp;y)</div><div class="ttdoc">Construct a new Enemy object for given coordinates.</div><div class="ttdef"><b>Definition:</b> Enemy.cpp:10</div></div>
<div class="ttc" id="aclassBomber_html_a978b4fce46f9b875fc412cb20bc2c001"><div class="ttname"><a href="classBomber.html#a978b4fce46f9b875fc412cb20bc2c001">Bomber::SetupStats</a></div><div class="ttdeci">void SetupStats() override</div><div class="ttdoc">Pure virtual function for setring up variables.</div><div class="ttdef"><b>Definition:</b> Enemy.cpp:89</div></div>
<div class="ttc" id="aclassEnemy_html_afba0cb1bba4839d19a4ea80dacbf5bcf"><div class="ttname"><a href="classEnemy.html#afba0cb1bba4839d19a4ea80dacbf5bcf">Enemy::m_ScoreValue</a></div><div class="ttdeci">int m_ScoreValue</div><div class="ttdef"><b>Definition:</b> Enemy.h:46</div></div>
<div class="ttc" id="aEntity_8h_html"><div class="ttname"><a href="Entity_8h.html">Entity.h</a></div></div>
<div class="ttc" id="aclassEnemy_html_a614ad271f07ecf63cb3e665155b7e258"><div class="ttname"><a href="classEnemy.html#a614ad271f07ecf63cb3e665155b7e258">Enemy::Update</a></div><div class="ttdeci">void Update() override</div><div class="ttdoc">Overrides update to also update weapon.</div><div class="ttdef"><b>Definition:</b> Enemy.cpp:47</div></div>
<div class="ttc" id="aclassCruiser_html_acee2ca8436026b2cd7562c5b45d5add1"><div class="ttname"><a href="classCruiser.html#acee2ca8436026b2cd7562c5b45d5add1">Cruiser::m_Clock</a></div><div class="ttdeci">std::chrono::time_point&lt; std::chrono::system_clock &gt; m_Clock</div><div class="ttdef"><b>Definition:</b> Enemy.h:106</div></div>
<div class="ttc" id="aclassFighter_html_a111291f871d86c69177b66b832078899"><div class="ttname"><a href="classFighter.html#a111291f871d86c69177b66b832078899">Fighter::SetupStats</a></div><div class="ttdeci">void SetupStats() override</div><div class="ttdoc">Pure virtual function for setring up variables.</div><div class="ttdef"><b>Definition:</b> Enemy.cpp:65</div></div>
<div class="ttc" id="aclassCruiser_html_a4a854fd717b42079b7b91bc4c06de455"><div class="ttname"><a href="classCruiser.html#a4a854fd717b42079b7b91bc4c06de455">Cruiser::m_StateSwitch</a></div><div class="ttdeci">bool m_StateSwitch</div><div class="ttdef"><b>Definition:</b> Enemy.h:107</div></div>
<div class="ttc" id="aclassDrone_html_a712934f484aa8b1a8f5d521f870217c0"><div class="ttname"><a href="classDrone.html#a712934f484aa8b1a8f5d521f870217c0">Drone::Drone</a></div><div class="ttdeci">Drone(const int &amp;x, const int &amp;y)</div><div class="ttdef"><b>Definition:</b> Enemy.cpp:109</div></div>
<div class="ttc" id="aclassCruiser_html_a1bdf01c4ccf5cb4305710274cfe5ae65"><div class="ttname"><a href="classCruiser.html#a1bdf01c4ccf5cb4305710274cfe5ae65">Cruiser::SetupStats</a></div><div class="ttdeci">void SetupStats() override</div><div class="ttdoc">Pure virtual function for setring up variables.</div><div class="ttdef"><b>Definition:</b> Enemy.cpp:171</div></div>
<div class="ttc" id="aclassEntity_html"><div class="ttname"><a href="classEntity.html">Entity</a></div><div class="ttdoc">Abstract class representing GameObjects that have weapon and health.</div><div class="ttdef"><b>Definition:</b> Entity.h:10</div></div>
<div class="ttc" id="aclassBomber_html"><div class="ttname"><a href="classBomber.html">Bomber</a></div><div class="ttdoc">Basic enemy with rocker launcher.</div><div class="ttdef"><b>Definition:</b> Enemy.h:65</div></div>
<div class="ttc" id="aclassFighter_html_a0ecbca6d3e98a60aa971c596375846c5"><div class="ttname"><a href="classFighter.html#a0ecbca6d3e98a60aa971c596375846c5">Fighter::InitWeapon</a></div><div class="ttdeci">void InitWeapon() override</div><div class="ttdoc">Pure virtual function for initializing weapon.</div><div class="ttdef"><b>Definition:</b> Enemy.cpp:76</div></div>
<div class="ttc" id="aclassEnemy_html"><div class="ttname"><a href="classEnemy.html">Enemy</a></div><div class="ttdoc">Represents enemy, it shoots diferent type of projectiles and has chance to drop bonus on death.</div><div class="ttdef"><b>Definition:</b> Enemy.h:15</div></div>
<div class="ttc" id="aclassEnemy_html_a44cdcdae0c7341918adbcfb7489d6b1f"><div class="ttname"><a href="classEnemy.html#a44cdcdae0c7341918adbcfb7489d6b1f">Enemy::Visit</a></div><div class="ttdeci">void Visit(CollisionVisitor *visitor) override</div><div class="ttdoc">Pure virtual function for accepting visitor.</div><div class="ttdef"><b>Definition:</b> Enemy.cpp:52</div></div>
<div class="ttc" id="aclassFighter_html"><div class="ttname"><a href="classFighter.html">Fighter</a></div><div class="ttdoc">Basic enemy with machinegun.</div><div class="ttdef"><b>Definition:</b> Enemy.h:53</div></div>
<div class="ttc" id="aclassCruiser_html_ae47dfbab1b9f7837d138f617a43593c1"><div class="ttname"><a href="classCruiser.html#ae47dfbab1b9f7837d138f617a43593c1">Cruiser::InitWeapon</a></div><div class="ttdeci">void InitWeapon() override</div><div class="ttdoc">Pure virtual function for initializing weapon.</div><div class="ttdef"><b>Definition:</b> Enemy.cpp:188</div></div>
<div class="ttc" id="aclassDrone_html_afdee1b510410d6512bd9898cfbbf2faf"><div class="ttname"><a href="classDrone.html#afdee1b510410d6512bd9898cfbbf2faf">Drone::SetupStats</a></div><div class="ttdeci">void SetupStats() override</div><div class="ttdoc">Pure virtual function for setring up variables.</div><div class="ttdef"><b>Definition:</b> Enemy.cpp:113</div></div>
<div class="ttc" id="aclassFighter_html_ad59b81c018ee965870f46fee88a5d469"><div class="ttname"><a href="classFighter.html#ad59b81c018ee965870f46fee88a5d469">Fighter::Fighter</a></div><div class="ttdeci">Fighter(const int &amp;x, const int &amp;y)</div><div class="ttdef"><b>Definition:</b> Enemy.cpp:61</div></div>
<div class="ttc" id="aclassCruiser_html_a28d17733c541e9985c3cab7efccc8138"><div class="ttname"><a href="classCruiser.html#a28d17733c541e9985c3cab7efccc8138">Cruiser::Cruiser</a></div><div class="ttdeci">Cruiser(const int &amp;x, const int &amp;y)</div><div class="ttdef"><b>Definition:</b> Enemy.cpp:143</div></div>
<div class="ttc" id="aclassEnemy_html_a42ec023b4093dcc4d68a7c9f9137d5a5"><div class="ttname"><a href="classEnemy.html#a42ec023b4093dcc4d68a7c9f9137d5a5">Enemy::Damage</a></div><div class="ttdeci">void Damage(const int &amp;dmg) override</div><div class="ttdoc">Overrides Damage function to try spawn bonus and add score to GameScene.</div><div class="ttdef"><b>Definition:</b> Enemy.cpp:14</div></div>
<div class="ttc" id="aclassEnemy_html_ac4582c2a7ccffc4dd2b8fd1d43017c33"><div class="ttname"><a href="classEnemy.html#ac4582c2a7ccffc4dd2b8fd1d43017c33">Enemy::CollideWith</a></div><div class="ttdeci">void CollideWith(GameObject *collisionObject) override</div><div class="ttdoc">Creates Visitor object and passes collisionObject parameter.</div><div class="ttdef"><b>Definition:</b> Enemy.cpp:56</div></div>
<div class="ttc" id="aclassEnemy_html_a59c9fcc0c3f927e15060a61b4753b1b3"><div class="ttname"><a href="classEnemy.html#a59c9fcc0c3f927e15060a61b4753b1b3">Enemy::BonusRoll</a></div><div class="ttdeci">void BonusRoll()</div><div class="ttdoc">Has chance to spawn bonus.</div><div class="ttdef"><b>Definition:</b> Enemy.cpp:23</div></div>
<div class="ttc" id="aclassCollisionVisitor_html"><div class="ttname"><a href="classCollisionVisitor.html">CollisionVisitor</a></div><div class="ttdoc">Abstract class of double dispatch visitor design patter.</div><div class="ttdef"><b>Definition:</b> CollisionVisitor.h:18</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.17
</small></address>
</body>
</html>
